#include <string.h>
#include <stdlib.h> 
#include "lcd.h"

#define CURSORDOWN 'X' -0x40
#define CURSORUP   'E' - 0x40

extern	char	GetKey(void);

/**********************************************************************
*
*	uchar	LCDListBox(char *Caption,Str40 Member[],uint MaxList,uint * Select)
*	eine Listbox auf dem Display ausgeben im Graphic Mode
*	und auf bestaetigung warten
*	return:
*		0 = Abbruch
*		1 = angenommen
*
***********************************************************************/
uchar	LCDListBox(char * szCaption,Str40 Member[],uint uiMaxList,uint * uiSelect)
{
	uint	uiXPixel,Len1,Len2,n,m,j;
	uchar	ucRedrawFlag,ucHighLight,*pbPtr,ucRetVal;
	Str40	ClearLine;
	char	ch;

	
	// speicher allocieren
	if ((pbPtr = (uchar*)malloc(BYTESPERLINE * MAXY)) == 0)	return(0);

	memset(ClearLine,' ',sizeof(Str40)-1);
	ClearLine[sizeof(Str40)-1] = 0;

	// screen inhalt wegspeichern
	LCDPushFrame(0,0,MAXX,MAXY,pbPtr);

	// laengstes element in der liste suchen
	Len2 = strlen(szCaption);
	for(n=0;n < uiMaxList;n++)
	{
		Len1 = strlen(Member[n]);
		if (Len1 > Len2) Len2 = Len1; 
	}
	// loesch zeile vorbereiten 
	ClearLine[Len2] = 0;

	// anzahl der Pixel berechen
	uiXPixel = (Len2+2) * CHARWIDTH;

	// frame loeschen
	LCDClearFrame(CENTERX-(uiXPixel/2),CENTERY-((5*CHARHEIGHT)/2),CENTERX+(uiXPixel/2),CENTERY+((5*CHARHEIGHT)/2));

	// rahmen zeichnen
	LCDDrawFrame((int)uiXPixel,(int)CHARHEIGHT*5,0);

	// ueberschrift ausgeben
	LCDCenterStrout(CENTERY-(2*CHARHEIGHT),szCaption);

	// die ersten 3 texte ausgeben
	
	if (*uiSelect < uiMaxList) n = *uiSelect;
	else
	{
		n = 0;
		*uiSelect = 0;
	}

	for(j=0;j < 3;j++,n++)
	{
		if (n < uiMaxList)
		{
			if (n == *uiSelect)
				LCDInversText();
			LCDCenterStrout(CENTERY-CHARHEIGHT+j*CHARHEIGHT,Member[n]);
			LCDNormalText();
		}
	}
	// abfrage welcher eintrag es den nun sein soll
	ucRedrawFlag = 0;
	ucRetVal = 0;

	do {
		// zeichen einlesen und verarbeiten
		ch = GetKey();
		switch(ch) {
		case CURSORDOWN:
			if (*uiSelect < (uiMaxList-1))
			{
				(*uiSelect)++;
				ucRedrawFlag = 1;
			}
			break;
		case CURSORUP:
			if (*uiSelect > 0)
			{
				(*uiSelect)--;
				ucRedrawFlag = 1;
			}
			break;
		case CR:
			ucRetVal = 1;
			break;
		case ESC:
			ucRetVal = 0;
			break;

		} // switch
		// liste eventuell neu ausgeben
		if (ucRedrawFlag)
		{
			ucRedrawFlag = 0;
			if (uiMaxList > 2)
			{
				if (*uiSelect == 0)
				{
					ucHighLight = 0;
					n = 0;
					if (uiMaxList > 3) m = 3;
					else			  m = uiMaxList;
				}
				else
				if (*uiSelect == (uiMaxList-1))
				{
					ucHighLight = 2;
					n = uiMaxList-3;
					m = uiMaxList;
				} else
				{
					ucHighLight = 1;
					n = *uiSelect-1;
					if (uiMaxList > (n+3)) m = n+3;
					else				 m = uiMaxList;
				}
			} else
			{
				n = 0;
				m = uiMaxList;
				if (*uiSelect == 0) ucHighLight = 0;
				else		  	   ucHighLight = 1;	
			} // if wMaxList
			for(j=0;n < m;n++,j++)
			{
				LCDCenterStrout(CENTERY-CHARHEIGHT+j*CHARHEIGHT,ClearLine);
				if (ucHighLight == j) LCDInversText();
				LCDCenterStrout(CENTERY-CHARHEIGHT+j*CHARHEIGHT,Member[n]);
				LCDNormalText();
			}	
		} // if bRedrawflag
	} while(ch != CR && ch != ESC);

	// alten bildschirminhalt wieder herstellen
	LCDPopFrame(0,0,MAXX,MAXY,pbPtr);

	free(pbPtr);
	return(ucRetVal);
}


