#include <stdlib.h>
#include <string.h>
#include "LCD.h"

typedef uchar DisplayType[MAXTEXTX];

static	DisplayType	*szTermBuffer;
static	uint		uiMaxBufferLines;
static	uint		uiDisplayPos;
static	uint		uiTermInLine;
static	uint		uiInPos;


/************************************************************************************************
*
*	void LCDVScrollInitTerminal(uint uiBufferLines)
*   Variablen initialisieren
*
*************************************************************************************************/
void	LCDVScrollInitTerminal(uint uiBufferLines)
{
	uint	n;

	if((szTermBuffer = malloc(uiBufferLines * MAXTEXTX)) == 0) return;

	uiMaxBufferLines = uiBufferLines;

	uiTermInLine = 0;
	uiInPos = 0;
	uiDisplayPos = uiBufferLines - MAXTEXTY;

	for(n=0;n < uiBufferLines;n++)
		memset(szTermBuffer[n],' ',MAXTEXTX);
}

/************************************************************************************************
*
*	void LCDVScrollTerminal(uchar ch)
*	zeichen in Buffer abspeichern und auf Display die zeile die in uiDisplayPos angegeben
*	ist ausgeben
*
*************************************************************************************************/
void	LCDVScrollTerminal(uchar ch)
{
	switch(ch){
	case CR:
		uiInPos = 0;
		break;
	case LF:											// wir fangen eine neue zeile an
		uiInPos = 0;									
		uiTermInLine++;
		if(uiTermInLine >= uiMaxBufferLines) uiTermInLine = 0;
		memset(szTermBuffer[uiTermInLine],' ',MAXTEXTX); // zeile loeschen
		LCDUpDateDisplay(uiDisplayPos);					 // display updaten
		break;
	case BS:
		if(uiInPos > 0) uiInPos--;
		szTermBuffer[uiTermInLine][uiInPos] = ' ';
		break;
	default:
		if(uiInPos < MAXTEXTX)							// Passt noch was in die Zeile ?
		{
			szTermBuffer[uiTermInLine][uiInPos] = ch;	// abspeichern und gut ist
			if(uiDisplayPos == (uiMaxBufferLines-MAXTEXTY))
			{
				LCDTextCursorOn();
				LCDTextCharOut((uchar)uiInPos,MAXTEXTY-1,ch,TEXTNORMAL);
				LCDTextSetCursor((uchar)uiInPos+1,MAXTEXTY-1);
			} else
				LCDTextCursorOff();
			uiInPos++;
		} else
		{
			uiInPos = 0;								// wir fangen eine neue zeile an
			uiTermInLine++;
			if(uiTermInLine >= uiMaxBufferLines) uiTermInLine = 0;
			memset(szTermBuffer[uiTermInLine],' ',MAXTEXTX); // zeile loeschen
			szTermBuffer[uiTermInLine][uiInPos++] = ch;
			LCDUpDateDisplay(uiDisplayPos);				// display updaten
		}
		break;
	}
}
/************************************************************************************************
*
*	void	LCDUpDateDisplay(uint uiLinePos)
*	Display zeilen updaten ab position uiLinePos
*
*************************************************************************************************/
void	LCDUpDateDisplay(uint uiLinePos)
{
	uchar	x,y;
	int		iPos;

	uiDisplayPos = uiLinePos;
	for(y=0;y < MAXTEXTY;y++)
	{
		iPos = (int)uiTermInLine - (int)uiMaxBufferLines + (int)uiLinePos + 1;
		if(iPos < 0)	iPos = (int)uiMaxBufferLines + iPos;
		for(x=0;x<MAXTEXTX;x++)
		{
			LCDTextCharOut(x,y,szTermBuffer[iPos][x],TEXTNORMAL);
		}
		if(iPos == (int)uiTermInLine) break;
		uiLinePos++;
	}	
}
