/*********************************************************************************************
*
*	char	BaudotToAscii(char ch)
*	Baudot code nach Ascii convertierung
*
**********************************************************************************************/
#define LETTERSHIFT 0x1f
#define FIGURESHIFT 0x1b

static	const	char	LetterTab[] = 
							{' ','E',0x0a,'A',' ','S','I','U',0x0d,'D','R','J','N','F','C','K',
						   'T','Z','L','W','H','Y','P','Q','O','B','G','@','M','X','V','@'};

static	const	char	FigureTab[] = 
							{' ','3',0x0a,'-',' ','\'','8','7',0x0d,'$','4',0x07,',','!',':','(',
						   '5','+',')','2','#','6','0','1','9','?','&','@','.','/',';','@'};

static	char	ucSwitchFlag;

char	BaudotToAscii(char ch)
{
	ch &= 0x1f;

	switch(ch){
	case LETTERSHIFT:
		ucSwitchFlag = 0;
		ch = 0;
		break;
	case FIGURESHIFT:
		ucSwitchFlag = 1;
		ch = 0;
		break;
	default:
		if(ucSwitchFlag) ch = FigureTab[ch];
		else			 ch = LetterTab[ch];
		break;	
	}
	return(ch);
}
	
