#include <string.h>
#include <stdlib.h>
#include <stdio.h>


#define uchar unsigned char
#define uint  unsigned int
#define CR 0x0d
#define LF 0x0a

extern	uchar*	strstr(uchar*,uchar*);

static	uchar	CollectString(uchar);		

static	uchar	szCollectStr[80];			// sammel string
static	uint	uiInPtr;					// ptr in straing
static	uchar	ucStartCollectFlag;			// strat stop daten sammel flag
static	uchar	*ucDataBuffer;				// der Data buffer selber
static	uchar	*pDataPtr;					// ptr in Buffer
static	uint	uiDataCnt;					// anzahl der zeichen im buffer
static	uint	uiMaxBufferSize;			// maximale grosse der Buffer
static	uchar	*ucMessageBuffer1;			// ptr auf message buffer 1
static	uchar	*ucMessageBuffer2;			// ptr auf Message buffer 2
static	uchar	ucUpdateFlag1;				// zeigt an das Buffer 1 upgedatete worden ist
static	uchar	ucUpdateFlag2;				// zeigt an das Buffer 2 upgedatete worden ist
static	uchar	szSearchPattern1[21];		// suchmuster fuer Buffer 1
static	uchar	szSearchPattern2[21];		// suchmuster fuer Buffer 2


/************************************************************************************************
*
*	void	InitCollect(void)
*			   
*************************************************************************************************/
void	InitCollect(uint uiMaxSize)
{
	uiInPtr = 0;
	szCollectStr[0] = 0;
	ucStartCollectFlag = 0;
	if((ucDataBuffer = (uchar*)malloc(uiMaxSize)) == 0) 	return;
	if((ucMessageBuffer1 = (uchar*)malloc(uiMaxSize)) == 0) return;
	if((ucMessageBuffer2 = (uchar*)malloc(uiMaxSize)) == 0) return;
	memset(ucMessageBuffer1,0,uiMaxSize);
	memset(ucMessageBuffer2,0,uiMaxSize);

	pDataPtr = ucDataBuffer;
	uiDataCnt = 0;
	uiMaxBufferSize = uiMaxSize;

	szSearchPattern1[0] = 0;
	szSearchPattern2[0] = 0;
	ucUpdateFlag1 = 0;
	ucUpdateFlag2 = 0;
}
/************************************************************************************************
*
*	void	StoreSearchPattern(uint uiNo,uchar *szStr)
*	such muster abspeichern
*			   
*************************************************************************************************/
void	StoreSearchPattern(uint uiNo,uchar *szStr)
{
	switch(uiNo){
	case 1:
		strcpy(szSearchPattern1,szStr);
		break;
	case 2:
		strcpy(szSearchPattern2,szStr);
		break;
	}
}
/************************************************************************************************
*
*	uchar	*GetBufferPtr(uint uiNo)
*	ptr auf buffer zurueck geben
*			   
*************************************************************************************************/
uchar	*GetBufferPtr(uint uiNo)
{
	switch(uiNo){
	case 1:	return(ucMessageBuffer1);
	case 2: return(ucMessageBuffer2);
	}
}
/************************************************************************************************
*
*	uchar	GetUpdateFlag(uint uiNo)
*	Buffer update flag ausgeben
*			   
*************************************************************************************************/
uchar	GetUpdateFlag(uint uiNo)
{
	uchar	ucFlag;
	switch(uiNo){
	case 1:	
		ucFlag = ucUpdateFlag1;
		ucUpdateFlag1 = 0;
		break;
	case 2: 
		ucFlag = ucUpdateFlag2;
		ucUpdateFlag2 = 0;
		break;
	}
	return(ucFlag);
}
/************************************************************************************************
*
*	void	CollectData(char ch)
*	daten einsammeln
*			   
*************************************************************************************************/
void	CollectData(uchar ch)
{
	uint	uiLen;

	if(CollectString(ch))
	{
		if(!strncmp(szCollectStr,"ZCZC",4)) 
		{
			ucStartCollectFlag = 1;
			pDataPtr = ucDataBuffer;
			uiDataCnt = 0;
		} else
		if(!strncmp(szCollectStr,"NNNN",4) && ucStartCollectFlag)
		{
			ucStartCollectFlag = 0;
			if(strstr(ucDataBuffer,szSearchPattern1) != NULL)
			{
				strcpy(ucMessageBuffer1,ucDataBuffer);
				ucUpdateFlag1 = 1;
			}
			if(strstr(ucDataBuffer,szSearchPattern1)!=NULL)
			{
				strcpy(ucMessageBuffer2,ucDataBuffer);
				ucUpdateFlag2 = 1;
			}
		} else
		{
			if(ucStartCollectFlag && uiDataCnt < (uiMaxBufferSize-1))
			{
				uiLen = strlen(szCollectStr);
				strcpy(pDataPtr,szCollectStr);
				pDataPtr += uiLen;
				*pDataPtr++ = LF;
				*pDataPtr = 0;
				uiDataCnt += (uiLen+1);
			}
		}
	}
}

/************************************************************************************************
*
*	uchar	CollectString(uchar ch)
*	zeichen in einem String sammeln bis LF eintrifft
*			   
*************************************************************************************************/
static	uchar	CollectString(uchar ch)
{
	switch(ch){
	case CR: 
		return(0);
	case LF:
		szCollectStr[uiInPtr] = 0;
		uiInPtr = 0;
		return(1);
	default:
		if(uiInPtr < sizeof(szCollectStr)-1)
		{
			szCollectStr[uiInPtr++] = ch;
			szCollectStr[uiInPtr] = 0;
		}
		return(0);
	}
}

